#include <iostream>
using namespace std;
#include "Pvs.h"
#include "Intersectable.h"

KdPvsData *
KdPvs::Find(KdNode *node)
{
  KdPvsMap::iterator i = mEntries.find(node);
  if (i != mEntries.end()) {
    //    cout<<node<<" "<<(*i).first<<" "<<(*i).second.mVisibleSamples<<endl;
    return &(*i).second;
  } else
    return NULL;
}

int
KdPvs::AddNodeSample(KdNode *node)
{
  int result;
  
  KdPvsData *data = Find(node);
  if (data) {
    data->mVisibleSamples++;
    result = 0;
  } else {
    mEntries[node] = KdPvsData(1);
    result = 1;
  }
  return  result;
}


void
KdPvs::GetData(const int index,
	       KdNode *&node,
	       KdPvsData &data
	       )
{
  KdPvsMap::iterator i = mEntries.begin();
  for (int k = 0; k!=index && i != mEntries.end(); i++, k++);
  node = (*i).first;
  data = (*i).second;
}

BspPvsData *BspPvs::Find(BspNode *node)
{
	BspPvsMap::iterator i = mEntries.find(node);
	
	if (i != mEntries.end()) 
	{
		//    cout<<node<<" "<<(*i).first<<" "<<(*i).second.mVisibleSamples<<endl;
		return &(*i).second;
	} 
	else
	  return NULL;
}

// TODO: Get common ancestor for bsp and kd tree (HierarchyNode)
int BspPvs::AddNodeSample(BspNode *node)
{
  int result;
  
  BspPvsData *data = Find(node);

  if (data) 
  {
	  data->mVisibleSamples ++;
	  result = 0;
  } 
  else 
  {
	  mEntries[node] = BspPvsData(1);
	  result = 1;
  }

  return  result;
}


void BspPvs::GetData(const int index, BspNode *&node, BspPvsData &data)
{
	BspPvsMap::iterator i = mEntries.begin();
  
	for (int k = 0; k!=index && i != mEntries.end(); i++, k++);

	node = (*i).first;
	data = (*i).second;
}

ViewCellPvsData *ViewCellPvs::Find(Intersectable *obj)
{
	ViewCellPvsMap::iterator i = mEntries.find(obj);
	
	if (i != mEntries.end()) 
	{
		//    cout<<node<<" "<<(*i).first<<" "<<(*i).second.mVisibleSamples<<endl;
		return &(*i).second;
	} 
	else
	  return NULL;
}

int ViewCellPvs::AddObject(Intersectable *obj)
{
	int result;
  
	ViewCellPvsData *data = Find(obj);

	if (data) 
	{
		data->mVisibleSamples ++;
		result = 0;
	} 
	else 
	{
		mEntries[obj] = ViewCellPvsData(1);
		result = 1;
	}

	return  result;
}

void ViewCellPvs::GetData(const int index, Intersectable *&obj, ViewCellPvsData &data)
{
	ViewCellPvsMap::iterator i = mEntries.begin();
  
	for (int k = 0; k!=index && i != mEntries.end(); i++, k++);

	obj = (*i).first;
	data = (*i).second;
}
